Serial Wombat Arduino Library

Loading...
Searching...
No Matches
Public Member Functions | List of all members
SerialWombatQuadEnc_18AB Class Reference

Extends the SerialWombatPWM class with SW18AB specific functionality, including frequency measurement and min/max/increment/target pin options. More...

`#include <SerialWombatQuadEnc.h>`

Inheritance diagram for SerialWombatQuadEnc_18AB:
[legend]
Collaboration diagram for SerialWombatQuadEnc_18AB:
[legend]

## Public Member Functions
| SerialWombatQuadEnc_18AB (SerialWombatChip &serialWombat)
int16_t | writeMinMaxIncrementTargetPin (uint16_t min=65535, uint16_t max=0, uint16_t increment=1, uint8_t targetPin=255)
int16_t | writeFrequencyPeriodmS (uint16_t period)
uint16_t | readFrequency ()
uint8_t | pin ()
| fulfills a virtual function requirement of SerialWombatAbstractProcessedInput
uint8_t | swPinModeNumber ()
| fulfills a virtual function requirement of SerialWombatAbstractProcessedInput
Public Member Functions inherited from SerialWombatQuadEnc
| SerialWombatQuadEnc (SerialWombatChip &serialWombatChip)
| Constructor for the SerialWombatQuadEnc class.
void | begin (uint8_t pin, uint8_t secondPin, uint16_t debounce_mS=10, bool pullUpsEnabled=true, QE_READ_MODE_t readState=QE_ONBOTH_POLL)
| Initialization for SerialWombatQuadEnc that allows configuration of debounce time, pullUps and transition detection mode.
uint16_t | read ()
| Read the quadrature encoder position from the Serial Wombat chip.
uint16_t | read (uint16_t replacementValue)
| Read the quadrature encoder position from the Serial Wombat chip then set the position value.
void | write (uint16_t value)
| This function initializes the position of the encoder.
Public Member Functions inherited from SerialWombatPin
| SerialWombatPin (SerialWombatChip &serialWombatChip)
| Instantiates a Serial Wombat Pin.
| SerialWombatPin (SerialWombatChip &serialWombatChip, uint8_t pin)
| Instantiates a Serial Wombat Pin.
uint16_t | readPublicData ()
| Read the 16 Bit public data associated with this pin.
void | pinMode (uint8_t mode, bool pullDown=false, bool openDrain=false)
| Set pin to INPUT or OUTPUT, with options for pull Ups and open Drain settings.
void | digitalWrite (uint8_t val)
| Set output pin High or Low.
int | digitalRead ()
| Reads the state of the Pin.
uint16_t | writePublicData (uint16_t value)
| Write a 16 bit value to this pin.
uint8_t | pin ()
| Returns the current SW pin number. Used primarily for virtual calls by derived classes.
uint8_t | swPinModeNumber ()
| Returns the Mode number. Used primarily by derived classes to populate packet data.
int16_t | initPacketNoResponse (uint8_t packetNumber, uint8_t param0=0x55, uint8_t param1=0x55, uint8_t param2=0x55, uint8_t param3=0x55, uint8_t param4=0x55)
int16_t | initPacketNoResponse (uint8_t packetNumber, uint16_t param0=0x55, uint8_t param1=0x55, uint8_t param2=0x55, uint8_t param3=0x55)
int16_t | initPacketNoResponse (uint8_t packetNumber, uint16_t param0, uint16_t param1, uint8_t param2=0x55)
int16_t | disable ()
| Disables the pin mode (if applicable)
int16_t | enablePullup (bool enabled)
| Enables the weak pull up on a pin. Implemented on SW18AB only.
int16_t | enablePullDown (bool enabled)
| Enables the weak pull down on a pin. Implemented on SW18AB only.
int16_t | enableOpenDrain (bool enabled)
| Enables open drain mode on a pin. Implemented on SW18AB only.
Public Member Functions inherited from SerialWombatAbstractProcessedInput
| SerialWombatAbstractProcessedInput (SerialWombatChip &sw)
| Constructor for the SerialWombatAbstractScaledOutput Class.
int16_t | writeInverted (bool inverted)
| if enabled subtract the input value from 65535 before doing any other processing.
int16_t | writeFirstOrderFilteringConstant (uint16_t constant)
| Set a first order filtering constant to be applied to the signal Higher is heavier filtering.
int16_t | writeAveragingNumberOfSamples (uint16_t numberOfSamples)
| Set a number of samples to average for each update of the downstream signal.
int16_t | writeExcludeBelowAbove (uint16_t low, uint16_t high)
| Sets input value ranges which are discarded rather than processed.
int16_t | configureQueue (SerialWombatQueue *queue, Period period, bool queueHighByte=true, bool queueLowByte=true)
| Sets up the queueing feature for this pin mode. Queue must have been initialized prior to this queue.
int16_t | configureOutputValue (OutputValue outputValue)
| Configures whether the pin's public data value is averaged, filtered, or neither.
int16_t | writeTransformScaleRange (uint16_t min, uint16_t max)
| Scale incoming values to a range of 0 to 65535.
int16_t | writeTransformLinearMXB (int32_t m, int32_t b)
| Scale incoming values based on an mx+b linear equation.
int16_t | configureIntegrator (uint16_t negativeMaxIndex, uint16_t negativeMidIndex, uint16_t negativeDeadZone, uint16_t positiveDeadZone, uint16_t positiveMidIndex, uint16_t positiveMaxIndex, uint16_t midIncrement, uint16_t maxIncrement, uint16_t initialValue, uint8_t updateFrequencyMask=0)
| Sort incoming data into one of 5 ranges, and integrate based on linear interpolation in those ranges.
int16_t | writeProcessedInputEnable (bool enabled)
| Enables or disables all input processing functions If disabled, the raw input value is placed directly in the pin's 16 bit public data buffer.
uint16_t | readMinimum (bool resetAfterRead=false)
| Retreive the maximum public data output value since the last call with reset= true.
uint16_t | readMaximum (bool resetAfterRead=false)
| Retreive the minimum public data output value since the last call with reset= true.
uint16_t | readAverage ()
| Retreive the last completed averaged value.
uint16_t | readFiltered ()
| Retreive the filtered value.

## Additional Inherited Members
Public Types inherited from SerialWombatAbstractProcessedInput
enum | Period { PERIOD_1mS = 0 , PERIOD_2mS = 1 , PERIOD_4mS = 2 , PERIOD_8mS = 3 , PERIOD_16mS = 4 , PERIOD_32mS = 5 , PERIOD_64mS = 6 , PERIOD_128mS = 7 , PERIOD_256mS = 8 , PERIOD_512mS = 9 , PERIOD_1024mS = 10 }
enum | OutputValue { RAW = 0 , FIRST_ORDER_FILTERED = 1 , AVERAGE = 2 }
enum | Transform { NONE = 0 , SCALE_RANGE = 1 , LINEAR_MXB = 2 }
Protected Attributes inherited from SerialWombatPin
uint8_t | _pin = 255
SerialWombatChip & | _sw
uint8_t | _pinMode = 0

## Detailed Description

Extends the SerialWombatPWM class with SW18AB specific functionality, including frequency measurement and min/max/increment/target pin options.

Definition at line 174 of file SerialWombatQuadEnc.h.

## Constructor & Destructor Documentation

## ◆ SerialWombatQuadEnc_18AB()

SerialWombatQuadEnc_18AB::SerialWombatQuadEnc_18AB | ( | SerialWombatChip & | serialWombat | ) |
| inline

Definition at line 177 of file SerialWombatQuadEnc.h.

## Member Function Documentation

## ◆ pin()

uint8_t SerialWombatQuadEnc_18AB::pin | ( |  | ) |
| inline virtual

fulfills a virtual function requirement of SerialWombatAbstractProcessedInput

Returns
  current pin number

Implements SerialWombatAbstractProcessedInput.

Definition at line 229 of file SerialWombatQuadEnc.h.

## ◆ readFrequency()

uint16_t SerialWombatQuadEnc_18AB::readFrequency | ( |  | ) |
| inline

Definition at line 214 of file SerialWombatQuadEnc.h.

## ◆ swPinModeNumber()

uint8_t SerialWombatQuadEnc_18AB::swPinModeNumber | ( |  | ) |
| inline virtual

fulfills a virtual function requirement of SerialWombatAbstractProcessedInput

Returns
  current pin mode number

Implements SerialWombatAbstractProcessedInput.

Definition at line 237 of file SerialWombatQuadEnc.h.

## ◆ writeFrequencyPeriodmS()

int16_t SerialWombatQuadEnc_18AB::writeFrequencyPeriodmS | ( | uint16_t | period | ) |
| inline

Definition at line 207 of file SerialWombatQuadEnc.h.

## ◆ writeMinMaxIncrementTargetPin()

int16_t SerialWombatQuadEnc_18AB::writeMinMaxIncrementTargetPin | ( | uint16_t | min = 65535,
|  | uint16_t | max = 0,
|  | uint16_t | increment = 1,
|  | uint8_t | targetPin = 255 )
| inline

Definition at line 180 of file SerialWombatQuadEnc.h.